# JS函数沙盒
- isolated-vm
    - https://www.npmjs.com/package/isolated-vm
        - vm => vm2 => isolated-vm
            - 官方API:https://nodejs.org/api/vm.html#vm_vm_executing_javascript
            - vm2放弃维护 => isolated-vm

# 云端编辑器
- 仅编码 
    - [JS代码编辑对比](https://en.wikipedia.org/wiki/Comparison_of_JavaScript-based_source_code_editors)
    - Monaco Editor [首选]
        - 支持diff模式
        - VSCode默认编辑器
    - Code Mirror https://codemirror.net/
        - 支持diff模式 https://codemirror.net/5/mode/diff/

- 集成IDE
    - code-server https://coder.com/
    - gitpod 底层Theia

# 环境允许模块
- module 云函数可写成module包形式，便于编写、加载和测试
- fetch 前后端同构网络请求库

# /func 函数执行接口

``` bash
curl -X POST http://127.0.0.1:1337/api/ncloud/func
```

# 云函数编写注意事项
- 关于打印调试
    - vm环境中console.log不可见
    - 需要return或者throw在调用外部打印具体结果